﻿### SCOPR Library
################################

require "cgi-lib.pl";
$scorp_version="SCORPJP Ver3.00";

### Define Colors
%scorp_color=(
"White" =>"\#FFFFFF",
"Gray"  =>"\#F1F1FF",
"Azure" =>"\#A2CDFF",
"Blue"  =>"\#60A0FF",
"DBlue" =>"\#4060FF",
"DDBlue"=>"\#000080",
"Orange"=>"\#FFCD60",
"Pink"  =>"\#FFAAAA"
);

%scorp_url=(
"style_sheet" =>"..\/style.css",
"corpus_top_dir"  =>"..\/CORPUS",
"logs"        =>"..\/SCORP_LOGS",
"search_word_history"=>"..\/SCORP_LOGS\/.search_word_history.sav",
"option_file" => "..\/SCORP_LOGS\/.scorp_option.sav",
"images"      =>"..\/images\/",
"login"       =>"..\/index.html",
"search"      =>".\/scorp_search.cgi",
"refresh"      =>".\/scorp_search.cgi",
"result"      =>".\/scorp_result.cgi",
"show_file"   =>".\/scorp_show_file.cgi",
"log"         =>".\/scorp_log.cgi",
"option"      =>".\/scorp_option.cgi"
);

%scorp_title=(
"search" =>"SCORP\: Search",
"result" =>"SCORP\: Result",
"log"=>"SCORP\: Log",
"option" =>"SCORP\: Option",
"detail" =>"SCORP\: Detail"
);

### SCOPR Login 
%array_corpus_dir=(
"id"      =>"0",
"select"  =>"1",
"dir_name"=>"2"
);

%select_value=(
"unselected"=>"0",
"selected"  =>"1"
);

%select_option=(
"0"=>" ",
"1"=>"selected"
);

### SCOPR Search 
%sort_key=(
"hitword"    =>"0",
"hitsentence"=>"1",
"word"       =>"2",
"frequency"  =>"3"
);

%sort_order=(
"ascending" =>"0",
"descending"=>"1"
);

%scorp_mode=(
"scorp"     =>"0",
"word_count"=>"1"
);

%menu_tab=(
"search"    =>"SEARCH",
"result"    =>"RESULT",
"log"       =>"LOG",
"option"    =>"OPTION"
);

@menu_tab_names=($menu_tab{"search"},$menu_tab{"result"},$menu_tab{"log"},$menu_tab{"option"});

%scorp_option=(
"max_result_rows"=>"20",
"max_result_columns"  =>"3",
"max_result_chars"  =>"80",
"max_search_word_history" =>"20"
);

### SCOPR Result 

%result_info_allfiles=(
"search_word"     => "0",
"search_file_num" => "1",
"search_line_num" => "2",
"hit_line_num"    => "3",
"hit_word_num"    => "4"
);

%result_info_eachfile=(
"search_word"     => "0",
"file_name"       => "1",
"guessed_code"    => "2",
"content"         => "3",
"search_line_num" => "4",
"hit_line_num"    => "5",
"hit_line_id"     => "6",
"hit_word_num"    => "7",
"hit_word_id"     => "8"
);

$LINE_SEPARATOR=":::LINESEPARATOR:::";
$HIGH_LIGHT_HEAD=":::HIGHLIGHT1:::";
$HIGH_LIGHT_TAIL=":::HIGHLIGHT2:::";

%result_info_eachhit=(
"file_name"     => "0",
"hit_line_id"   => "1",
"hit_line"      => "2",
"hit_word"      => "3",
"hit_paragraph" => "4",
"hit_paragraph_highlighted" => "5"
);

### Function

### PRINT_SCORP_HEAD
sub print_scorp_head{
	my ($title,$menu,$v_search_word,$v_search_dir,$v_sort_key,$v_sort_order,$v_result_page) = @_;
	print "Content-type: text/html\n\n";
	print <<EOF;
<html LANG=ja>
<head>
<title>$title</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf8">
<link rel="stylesheet" href="$scorp_url{"style_sheet"}">
</head>
<body>
<div class="scorp-page">
<div class="scorp-head"><img src="$scorp_url{'images'}scorp_head.jpg" alt="headimage" border="0"></div>
EOF
	&print_scorp_tab_menu($menu,$v_search_word,$v_search_dir,$v_sort_key,$v_sort_order,$v_result_page);
}

### PRINT_SCORP_FOOT
sub print_scorp_foot{
	print <<EOF;
<div class="scorp-foot">
<img src="$scorp_url{'images'}scorp_foot.jpg" alt="footimage" border="0">
</div>
<div class="scorp-foot-email">
$scorp_version
<br>
<a class="scorp-foot-email" href="mailto:takasato\@ipc.akita-u.ac.jp">email: takasato\@ipc.akita-u.ac.jp</a>
</div>
</div>
</body>
</html>
EOF
}

### PRINT_SCORP_TAB_MENU
sub print_scorp_tab_menu{
	my ($focus_menu,$v_search_word,$v_search_dir,$v_sort_key,$v_sort_order,$v_result_page) = @_;
	print <<EOF;
<div class="scorp-menu">
<table class="scorp-menu" width="100%">
<tbody>
<tr>
EOF
	if($focus_menu eq $menu_tab{'search'}){
		print <<EOF;
<td class="scorp-menu-focus" width="25%">
EOF
	}else{
		print <<EOF;
<td class="scorp-menu" width="25%">
EOF
	}
	print <<EOF;
<center>	
<form action="$scorp_url{"search"}" method="POST">
<input type="image" src="$scorp_url{'images'}menu_search.gif" alt="$menu_tab{"search"}" align="middle">
<input type="hidden" name="v_search_word" value="$v_search_word">
<input type="hidden" name="v_search_dir" value="$v_search_dir">
<input type="hidden" name="v_sort_key" value="$v_sort_key">
<input type="hidden" name="v_sort_order" value="$v_sort_order">
<input type="hidden" name="v_result_page" value="$v_result_page">
</form>
</center>
</td>
EOF
	if($focus_menu eq $menu_tab{'result'}){
		print <<EOF;
<td class="scorp-menu-focus" width="25%">
EOF
	}else{
		print <<EOF;
<td class="scorp-menu" width="25%">
EOF
	}
	print <<EOF;
<center>
<form action="$scorp_url{"result"}" method="POST">
<input type="image" src="$scorp_url{'images'}menu_result.gif" alt="$menu_tab{"result"}" align="middle">
<input type="hidden" name="v_search_word" value="$v_search_word">
<input type="hidden" name="v_search_dir" value="$v_search_dir">
<input type="hidden" name="v_sort_key" value="$v_sort_key">
<input type="hidden" name="v_sort_order" value="$v_sort_order">
<input type="hidden" name="v_result_page" value="$v_result_page">
</form>
</center>
</td>
EOF
	if($focus_menu eq $menu_tab{'log'}){
		print <<EOF;
<td class="scorp-menu-focus" width="25%">
EOF
	}else{
		print <<EOF;
<td class="scorp-menu" width="25%">
EOF
	}
	print <<EOF;
<center>	
<form action="$scorp_url{"log"}" method="POST">
<input type="image" src="$scorp_url{'images'}menu_log.gif" alt="$menu_tab{"log"}" align="middle">
<input type="hidden" name="v_search_word" value="$v_search_word">
<input type="hidden" name="v_search_dir" value="$v_search_dir">
<input type="hidden" name="v_sort_key" value="$v_sort_key">
<input type="hidden" name="v_sort_order" value="$v_sort_order">
<input type="hidden" name="v_result_page" value="$v_result_page">
</form>
</center>	
</td>
EOF
	if($focus_menu eq $menu_tab{'option'}){
		print <<EOF;
<td class="scorp-menu-focus" width="25%">
EOF
	}else{
		print <<EOF;
<td class="scorp-menu" width="25%">
EOF
	}
	print <<EOF;
<center>	
<form action="$scorp_url{"option"}" method="POST">
<input type="image" src="$scorp_url{'images'}menu_option.gif" alt="$menu_tab{"option"}" align="middle">
<input type="hidden" name="v_search_word" value="$v_search_word">
<input type="hidden" name="v_search_dir" value="$v_search_dir">
<input type="hidden" name="v_sort_key" value="$v_sort_key">
<input type="hidden" name="v_sort_order" value="$v_sort_order">
<input type="hidden" name="v_result_page" value="$v_result_page">
</form>
</center>	
</td>
</tr>
</tbody>
</table>
</div>
EOF
}

### LOAD_CORPUS_DIR
### LOAD_SEARCH_WORD_HISTORY
### WRITE_SEARCH_WORD_HISTORY
### CLEAR_SEARCH_WORD_HISTORY
sub load_corpus_dir{
	my ($v_corpus_top_dir,$v_max_result_rows,$v_max_result_columns,$v_max_result_chars,$v_max_search_word_history)=&read_scorp_option;
	my $tmp=$v_corpus_top_dir;
	my $tmp1;
	my $id=0;
	my @corpus_dir;
	opendir(DIR,$tmp) || &CgiDie("$tmp:$!");
	while($tmp1=readdir(DIR)){
		if($tmp1!~ /^\.*$/){
			if(-d "$v_corpus_top_dir\/$tmp1"){
				push(@corpus_dir,"$v_corpus_top_dir\/$tmp1");
			}
		}
	}
	close(DIR);

	foreach $tmp (@corpus_dir){
		opendir(DIR,$tmp) || &CgiDie("$tmp:$!");
		while($tmp1=readdir(DIR)){
			if($tmp1!~ /^\.*$/){
				if(-d "$v_corpus_top_dir\/$tmp\/$tmp1"){
					push(@corpus_dir,"$tmp\/$tmp1");
				}
			}	
		}
	}
	close(DIR);
	@corpus_dir = sort{$a cmp $b} @corpus_dir;
	return @corpus_dir;
}
sub load_search_word_history{
	my $tmp=$scorp_url{"search_word_history"};
	my $tmp0=$scorp_url{"logs"};
	my @search_word_history;
	if(-d $scorp_url{"logs"}){
		;
	}else{
		system("mkdir $tmp0");
		system("chmod 0707 $tmp0");
	}
	if(!(-f $tmp)){
		&clear_search_word_history;
	}
	open(IN,$tmp) || &CgiDie("$tmp:$!");
	while(<IN>){
		my $line=$_;
		chomp $line;
		unshift(@search_word_history,$line);
	}
	close(IN);
	return @search_word_history;
}
sub write_search_word_history{
	my ($search_word,$v_max_search_word_history)= @_;
	my $tmp=$scorp_url{"search_word_history"};
	if(!(-f $tmp)){
		&clear_search_word_history;
	}
	my $tmp0;
	my @tmp1;
	open(IN,$tmp)||&CgiDie("$tmp:$!");
	while(<IN>){
		$tmp0=$_;
		chomp $tmp0;
		push(@tmp1,$tmp0);
	}
	close(IN);
	push(@tmp1,$search_word);

	my $tmp2=@tmp1;
	my $tmp3=$tmp2-$v_max_search_word_history;
	open(OUT,">$tmp")||&CgiDie("$tmp:$!");
	if($tmp3>0){
		for($tmp4=$tmp3;$tmp4<$v_max_search_word_history+$tmp3;$tmp4++){
			print OUT "$tmp1[$tmp4]\n";
		}
	}else{
		foreach (@tmp1){
			print OUT "$_\n";
		}
	}
	close(OUT);
}

sub clear_search_word_history{
	my $tmp=$scorp_url{"search_word_history"};
	my $tmp0=$scorp_url{"logs"};
	if(-d $scorp_url{"logs"}){
		;
	}else{
		system("mkdir $tmp0");
		system("chmod 0707 $tmp0");
	}
	open(OUT,">$tmp") || &CgiDie("$tmp:$!");
	close(OUT);
	system("chmod 0707 $tmp");
	&show_dialog_jump($scorp_url{'search'},"SEARCH KEY HISTORY CLEARED.");
	exit(-1);
}

### READ_LIST_CORPUS_FILES
sub read_corpus{
	my $v_search_dirs= shift @_;
	my @v_search_dir=split(/[\0\,]/,$v_search_dirs);
	my @search_files;
	foreach (@v_search_dir){
		my @files=glob("$_\/*");
		foreach (@files){
			if(-f $_){
				push(@search_files,$_);
			}		
		}
	}
	return \@search_files;
}

### SHOW DIALOG and JUMP to DESTINATION PAGE
sub show_dialog_jump{
	my ($v_destination_url,$v_dialog) = @_;
	print "Content-type: text/html\n\n";
	print <<EOF;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html LANG=ja>
<head>
<title>SCORP: Dialog and Auto-Jump</title>
<meta http-equiv="Refresh" content="3; url=$v_destination_url">
<link rel="stylesheet" href="$scorp_url{"style_sheet"}">
<style media="screen" type"text/css">
</head>
<body>
<div class="scorp-page">
<div class="scorp-head"><img src="$scorp_url{'images'}scorp_head.jpg" alt="headimage" border="0"></div>
<div class="scorp-body">
<h3 class="scorp-body">
$v_dialog
</h3>
</div>
EOF
	&print_scorp_foot;
}

sub read_scorp_option{
	my $tmp=$scorp_url{'option_file'};
	my $tmp0=$scorp_url{'logs'};
	my $v_corpus_top_dir=$v_max_result_rows=$v_max_result_columns=$v_max_result_chars=$v_max_search_word_histrory;
	my @tmp2;
	if(-d $tmp0){
		;
	}else{
		system("mkdir $tmp0");
		system("chmod 0707 $tmp0");
	}
	if(-f "$tmp"){
		open(IN,"$tmp")||&CgiDie("$tmp:$!");
		while(<IN>){
			if($_=~ /corpus_top_dir\t(.+)/){
				$v_corpus_top_dir = $1;
			}elsif($_=~ /max_result_rows\t(\d+)/){
				$v_max_result_rows = $1;
			}elsif($_=~ /max_result_columns\t(\d+)/){
				$v_max_result_columns = $1;
			}elsif($_=~ /max_result_chars\t(\d+)/){
				$v_max_result_chars = $1;
			}elsif($_=~ /max_search_word_history\t(\d+)/){
				$v_max_search_word_history = $1;
			}
		}
		close(IN);
		@tmp2=($v_corpus_top_dir,$v_max_result_rows,$v_max_result_columns,$v_max_result_chars,$v_max_search_word_history);
	}else{
		my $tmp=$scorp_url{'option_file'};
		$v_corpus_top_dir=$scorp_url{'corpus_top_dir'};
		$v_max_result_rows=$scorp_option{'max_result_rows'};
		$v_max_result_columns=$scorp_option{'max_result_columns'};
		$v_max_result_chars=$scorp_option{'max_result_chars'};
		$v_max_search_word_history=$scorp_option{'max_search_word_history'};
		open(OUT,">$tmp")||&CgiDie("$tmp:$!");
		print OUT "corpus_top_dir\t$v_corpus_top_dir\n";
		print OUT "max_result_rows\t$v_max_result_rows\n";
		print OUT "max_result_columns\t$v_max_result_columns\n";
		print OUT "max_result_chars\t$v_max_result_chars\n";
		print OUT "max_search_word_history\t$v_max_search_word_history\n";
		close(OUT);
		system("chmod 0707 $tmp");
		@tmp2=($v_corpus_top_dir,$v_max_result_rows,$v_max_result_columns,$v_max_result_chars,$v_max_search_word_history);
	}
	return @tmp2;
}

sub symbol_code{
	my $line= shift @_;
	#$line=~ s/ /&nbsp;/g;
	#$line=~ s/\"/&quot;/g;
	$line=~ s/\&/&amp;/g;
	$line=~ s/</&lt;/g;
	$line=~ s/>/&gt;/g;
	return $line;
}
	
