#!/usr/bin/perl
#scorp_option.cgi
#

require "./scorp-lib.pl";

use utf8;

&ReadParse;

my $v_search_word = $in{'v_search_word'}; 
my @v_search_dir  = split(/[\0\,]/,$in{'v_search_dir'}); 
my $v_search_dirs;
foreach (@v_search_dir){
	$v_search_dirs=$v_search_dirs.$_.",";
}
my $v_sort_key = $in{'v_sort_key'}; 
my $v_sort_order = $in{'v_sort_order'}; 
my $v_result_page = $in{'v_result_page'};

my $v_corpus_top_dir = $in{'v_corpus_top_dir'};
my $v_max_result_rows = $in{'v_max_result_rows'};
my $v_max_result_columns = $in{'v_max_result_columns'};
my $v_max_result_chars = $in{'v_max_result_chars'};
my $v_max_search_word_history = $in{'v_max_search_word_history'};

if($v_max_result_rows!~ /[\d]+/){
	($v_corpus_top_dir,$v_max_result_rows,$v_max_result_columns,$v_max_result_chars,$v_max_search_word_history)=&read_scorp_option;
}else{
	&write_scorp_option;
	&show_dialog_jump($scorp_url{'search'},"OPTION(s) SAVED.");
	exit(-1);
}
my @result_rows=(20,30,40,50,100);
my @result_columns=(1,2,3);
my @result_chars=(20,40,80,100,120);
my @search_word_history=(20,40,80,100);

##############################################

&print_scorp_head($scorp_title{"option"},$menu_tab{"option"},$v_search_word,$v_search_dirs,$v_sort_key,$v_sort_order,$v_result_page);
#print "word:$v_search_word;<br>dir:$v_search_dirs;<br>key:$v_sort_key;<br>order:$v_sort_order;<br>page:$v_result_page;<br>";

&display_scorp_option;
&print_scorp_foot;

sub display_scorp_option{
	print <<EOF;
<div class="scorp-body">
<center>
<form action="$scorp_url{"option"}" method="post"> 
<table class="scorp-body" border="0">
<caption>
<tr>
<td class="scorp-body" align="left">
<div style="margin-left: 20px">
<em class="scorp-body">Location of the CORPUS Top Directory</em>
</div>
</td>
<td class="scorp-body">
<input type="text" name="v_corpus_top_dir" size="20" value="$v_corpus_top_dir">
</td>
<td class="scorp-body" align="left">
<em class="scorp-body">Relative Path from the cgi-bin Directory</em>
<br>
Default Location: ../CORPUS
</td>
</tr>
<tr>
<td class="scorp-body" align="left">
<div style="margin-left: 20px">
<em class="scorp-body">Max Number of Rows</em> for the Table of Result
</div>
</td>
<td class="scorp-body">
<select name="v_max_result_rows" multiple size="5">
EOF
foreach (@result_rows){
	if($v_max_result_rows==$_){
		print <<EOF;
<option value="$_" selected>$_</option>
EOF
	}else{
		print <<EOF;
<option value="$_">$_</option>
EOF
	}
}
print <<EOF;
</select>
</td>
<td class="scorp-body" align="left">
for the <em class="scorp-body">SCORP</em> Result
<br>
Default Value: 20
</td>
</tr>
<tr>
<td class="scorp-body" align="left">
<div style="margin-left: 20px">
<em class="scorp-body">Max Length of Characters</em> for the Hit Sentence
</div>
</th>
<td class="scorp-body">
<select name="v_max_result_chars" multiple size="5">
EOF
foreach (@result_chars){
	if($v_max_result_chars==$_){
		print <<EOF;
<option value="$_" selected>$_</option>
EOF
	}else{
		print <<EOF;
<option value="$_">$_</option>
EOF
	}
}
print <<EOF;
</select>
</td>
<td class="scorp-body" align="left">
for the <em class="scorp-body">SCORP</em> Result
<br>
Default Value: 80
</td>
</tr>
<tr>
<td class="scorp-body" align="left">
<div style="margin-left: 20px">
<em class="scorp-body">Max Amount of the Search Key History Record
</div>
</th>
<td class="scorp-body">
<select name="v_max_search_word_history" multiple size="4">
EOF
foreach (@search_word_history){
	if($v_max_search_word_history==$_){
		print <<EOF;
<option value="$_" selected>$_</option>
EOF
	}else{
		print <<EOF;
<option value="$_">$_</option>
EOF
	}
}
print <<EOF;
</select>
</td>
<td class="scorp-body" align="left">
Default Value: 20
</td>
</tr>
</table>
<input type="submit" value="SAVE">
<input type="hidden" name="v_search_word" value="$v_search_word">
<input type="hidden" name="v_search_dir" value="$v_search_dirs">
<input type="hidden" name="v_sort_key" value="$v_sort_key">
<input type="hidden" name="v_sort_order" value="$v_sort_order">
<input type="hidden" name="v_result_page" value="$v_result_page">
</form>
</div>
EOF
}

sub write_scorp_option{
	$v_max_result_columns=3;
	my $tmp=$scorp_url{'option_file'};
	open(OUT,">$tmp")||&CgiDie("$tmp:$!");
	print OUT "corpus_top_dir\t$v_corpus_top_dir\n";
	print OUT "max_result_rows\t$v_max_result_rows\n";
	print OUT "max_result_columns\t$v_max_result_columns\n";
	print OUT "max_result_chars\t$v_max_result_chars\n";
	print OUT "max_search_word_history\t$v_max_search_word_history\n";
	close(OUT);
}
